<?php
class FW_Form
{
  protected $parameters = array();
  protected $elements = array();
  
  public function __construct($name, $method, $action)
  {
     if(strtolower($method) != "post" && strtolower($method) != "get")
     {
       throw new FW_Form_Exception("Der 2. Parameter des Konstruktors muss get oder post sein");
     }
     $this->parameters["name"] = $name;
     $this->parameters["method"] = $method;
     $this->parameters["action"] = $action;
  }
  
  public function setParameter($name, $value)
  {
    $name = strtolower($name);
    $this->parameters[$name] = $value;
  }
  
  public function addElement(FW_Form_Element_Abstract $element, $position = null)
  {
    if($position === null || !is_int($position))
    {
      $this->elements[] = $element;
    }
    else
    {
      $this->elements[$position] = $element;
    }
    return $this;
  }
  
  public function getElementByPosition($position)
  {
    if(is_int($position) && isset($this->elements[$position]))
    {
      return $this->elements[$position];
    }
    else
    {
      throw new FW_Form_Exception("Diese Position hat einen ungültigen Wert");
    }
  }
  
  public function getElementByName($name)
  {
    foreach($this->elements as $element)
    {
      if($name == $element->getName())
      {
        return $element;
      }
    }
    return null;
  }
  
  public function validate()
  {
    foreach($this->elements as $element)
    {
      if(!$element->validate())
      {
        return true;
      }
    }
    return true;
  }
  
  public function __toString()
  {
    $html = "<form";
    foreach($this->parameters as $name => $value)
    {
      $html .= " ".$name."='".$value."'";
    }
    $html .= ">";
    
    foreach($this->elements as $k => $element)
    {
      $html .= "\n ".$element->getHTML()."\n";
    }
    
    $html .="</form>";
     
    return $html;
  }
}
?>